unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, jpeg;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    Edit3: TEdit;
    Label3: TLabel;
    Button1: TButton;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Button2: TButton;
    Label6: TLabel;
    Edit6: TEdit;
    Image1: TImage;
    Button5: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo2: TMemo;
    Image2: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit5Exit(Sender: TObject);
    procedure FdisO (Nu1, Nu2 : integer; XX : real; var Prob : real);
    procedure FdisE (Mu1, Mu2 : integer; XX : real; var Probi : real);
    procedure ProbdisO (Nu1, Nu2 : integer; Proba : real; var XX : real);
    procedure ProbdisE (Mu1, Mu2 : integer; Proba : real; var XX : real);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure GetProb(Sender: TObject);
    procedure MakeProbs (Nu1, Nu2 : integer);
    procedure MakeProbsE (Mu1, Mu2 : integer);
    procedure MakeProbGraph;
    procedure MakeFtestGraph;
    procedure MakeDensGraph;
    procedure MakeInitialGraph;
    function StringToFloat(Str : string) : double;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  const                         {tbv graphics}
  PosX1=50;
  PosX2=PosX1+320;
  PosY1=50;
  PosY2=PosY1+180;

var
  Form1: TForm1;
  DF1, DF2 : integer;
  Ftest, Probab, Fval, XX, Probabi :real;
  Probability, Fvalue, Density, TmpVal : array [1..1000] of real;
  Pro : array [1..100000] of real;
  Case1, Case2 : boolean;
  InitDecSep : char;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text:='1';
  DF1:=1;
  Edit2.Text:='10';
  DF2:=10;
  Edit3.Text:='4.11';
  Ftest:=4.1;
  Edit4.Text:='93';
  Edit5.Text:='';
  Probab:=93;
  Button3.Enabled:=true;
  Button4.Enabled:=true;
  Button5.Enabled:=true;
  MakeInitialGraph;
  Edit6.Text:='';
  Case1:=true;
  InitDecSep:=DecimalSeparator;
end;


procedure TForm1.Edit1Change(Sender: TObject);
begin
  Edit4.Text:='';
  Edit6.Text:='';
  Button3.Enabled:=false;
  Button4.Enabled:=false;
  Button5.Enabled:=false;
  MakeInitialGraph;
end;


procedure TForm1.Edit1Exit(Sender: TObject);
begin
  DF1:=round(stringtofloat(Edit1.text));
  DecimalSeparator:=InitDecSep;
  Edit1.Text:=inttostr(DF1);
  if DF1<=0 then
  begin
    Edit1.Text:='1';
    DF1:=1;
  end;
  if Edit1.Text='' then Button3.Enabled:=false;
end;


procedure TForm1.Edit2Change(Sender: TObject);
begin
  Edit4.Text:='';
  Edit6.Text:='';
  Button3.Enabled:=false;
  Button4.Enabled:=false;
  Button5.Enabled:=false;
  MakeInitialGraph;
end;


procedure TForm1.Edit2Exit(Sender: TObject);
begin
  DF2:=round(stringtofloat(Edit2.text));
  DecimalSeparator:=InitDecSep;
  Edit2.Text:=inttostr(DF2);
  if DF2<=0 then
  begin
    Edit2.Text:='10';
    DF2:=10;
  end;
end;


procedure TForm1.Edit3Change(Sender: TObject);
begin
  Edit4.Text:='';
  Button3.Enabled:=false;
  Button4.Enabled:=false;
  Button5.Enabled:=false;
  if (Edit5.Text<>'') and (Edit6.Text<>'') then
  begin
    Button2.Enabled:=true;
    Button3.Enabled:=true;
    Button4.Enabled:=true;
    Button5.Enabled:=true;
  end;
  Button1.Enabled:=true;
  if Edit3.Text='' then Case1:=false;
  if Edit3.Text='' then Button1.Enabled:=false;
  if Edit3.Text<>'' then Button1.Enabled:=true;
  MakeInitialGraph;
end;


procedure TForm1.Edit3Exit(Sender: TObject);
begin
  if Edit3.Text='' then Button1.Enabled:=false
  else Button1.Enabled:=true;
  if Edit3.Text='' then Case1:=false;
end;


procedure TForm1.Edit5Change(Sender: TObject);
begin
  Edit6.Text:='';
    Button1.Enabled:=true;
  Button3.Enabled:=false;
  Button4.Enabled:=false;
  Button5.Enabled:=false;
  if (Edit3.Text<>'') and (Edit4.Text<>'') then
  begin
    Button1.Enabled:=true;
    Button3.Enabled:=true;
    Button4.Enabled:=true;
    Button5.Enabled:=true;
  end;
  if (Edit5.Text<>'') and (Edit6.Text<>'') then
  begin
    Button1.Enabled:=true;
    Button3.Enabled:=true;
    Button3.Enabled:=true;
    Button5.Enabled:=true;
  end;
  Button2.Enabled:=true;
  if Edit5.Text='' then Case1:=true;
  if Edit5.Text='' then Button2.Enabled:=false;
  MakeInitialGraph;
end;


procedure TForm1.Edit5Exit(Sender: TObject);
var AuxVal : real;
begin
  AuxVal:=stringtofloat(Edit5.Text);
  DecimalSeparator:=InitDecSep;
  if AuxVal>99.9 then Edit5.Text:='99.9';
  if Edit5.Text='' then Button2.Enabled:=false
  else Button2.Enabled:=true;
end;



procedure TForm1.Button1Click(Sender: TObject);
var Prob, TmpValue : real;

begin
  if edit3.text='' then
  begin
    showmessage ('Please enter the F-test value');
    exit;
  end;

  Button3.Visible:=true;
  Button3.enabled:=true;
  Button4.Visible:=true;
  Button4.enabled:=true;
  Button5.Visible:=true;
  Button5.enabled:=true;
  Memo2.Visible:=false;
  image1.Visible:=true;
  image2.Visible:=false;
  TmpValue:=strtofloat (edit3.text);
  if Tmpvalue>10 then Button5.enabled:=false;
  if TmpValue>20 then
  begin
    Button3.Visible:=false;
    Button4.Visible:=false;
    Button5.Visible:=false;
    Memo2.Visible:=true;
    image1.Visible:=false;
    image2.Visible:=true;
  end;


  Case1:=true;
  Edit6.Text:='';
  Button3.Caption:='See probability graph';
  DF1:=strtoint(Edit1.text);
  DF2:=strtoint(Edit2.text);
  Ftest:=stringtofloat(Edit3.text);
  DecimalSeparator:=InitDecSep;

  if (Frac(DF1/2)=0) and (Frac(DF2/2)=0) then
  begin
    if DF1<=DF2 then FdisE (DF1,DF2,Ftest,Prob)
    else FdisO (DF1,DF2,Ftest,Prob);
  end;
  if (Frac(DF1/2)=0) and (Frac(DF2/2)<>0) then FdisE (DF1,DF2,Ftest,Prob);
  if (Frac(DF1/2)<>0) and (Frac(DF2/2)<>0) then
  begin
    if (DF1=1) and (DF2=1) then FdisE (DF1,DF2,Ftest,Prob)
    else
      if DF1<DF2 then
      begin
        FdisO (DF1,DF2-1,Ftest,Prob);
        TmpValue:=Prob;
        FdisO (DF1,DF2+1,Ftest,Prob);
        Prob:=(3*Prob+TmpValue)/4;
      end else
      begin
        FdisE (DF1-1,DF2,Ftest,Prob);
        TmpValue:=Prob;
        FdisE (DF1+1,DF2,Ftest,Prob);
        Prob:=(3*Prob+TmpValue)/4;
      end;
  end;
  if (Frac(DF1/2)<>0) and (Frac(DF2/2)=0) then FdisO (DF1,DF2,Ftest,Prob);

  if Prob>99.9 then Prob:=99.9;
  Edit4.text:=format('%4.1f',[Prob]);

  MakeInitialGraph;
  Case1:=true;
end; {Button1Click}


procedure TForm1.GetProb(Sender: TObject);
var DD1, DD2 : integer; Prob, Proba : real;

begin
  DD1:=DF1;
  DD2:=DF2;
  if frac(DF1)<>0 then DF1:=DF1+1;
  FdisE (DF1,DF2,Ftest,Prob);
  Proba:=Prob;
  if frac(DF2)<>0 then DF2:=DF2+1;
  FdisO (DF1,DF2,Ftest,Prob);
  Prob:=DF1*Proba/(DF1+DF2) + DF2*Prob/(DF1+DF2);
  if Prob>99 then Prob:=99;
  if Prob<0.1 then Prob:=0.1;
  Probabi:=Prob;
  DF1:=DD1;
  DF2:=DD2;
end; {GetProb}


procedure TForm1.FdisO (Nu1, Nu2 : integer; XX : real; var Prob : real);
{---------------------------------------------------------------------}

Var jj : integer;
    AA, Added, Aux1, Aux2, Factor, Tau : real;
    Term : array of real;
//Symbols could be changed Factor -> Sum, Term -> Factor, Aux -> Term
begin

  Tau := Nu2/(Nu2+Nu1*XX);
  setlength (Term,2);
  Term[1]:=Nu1*(Nu1+2)/8;                        //factor of Tau
  Aux1:=Term[1]*sqr(Tau);                        //Third term
  Factor:=1+Nu1*Tau/2+Aux1;                      //Sum of first three terms
  jj:=1;
  Added:=4;
  while (Added<Nu2-3) and (jj<300) do
  begin
    jj:=jj+1;
    setlength (Term,jj+1);
    Term[jj]:=Term[jj-1]*(Nu1+Added)/(Added+2);
    AA:=(jj+1)*ln(Tau);
    AA:=exp(AA);
    Aux2:=Term[jj]*AA;                           //next term
    Factor:=Factor+Aux2;                         //Summation of terms
    Added:=Added+2;
  end; {while (Added<Nu2-3) and (jj<300) do}
  if Tau<1 then
  begin
    AA := (Nu1/2)*ln(1-Tau);
    AA := exp(AA);
  end
  else
    AA := 0;
  if Nu2=4 then Factor:=Factor-Aux1;
  if Nu2=2 then Factor:=1;
  if Nu2=1 then Factor:=0.6375;
  Prob := 100*AA*Factor;
  if Prob>99.99 then Prob:=99.99;
end;
{end of FdisO}
{------------}



procedure TForm1.FdisE (Mu1, Mu2 : integer; XX : real; var Probi : real);
{-----------------------------------------------------------------------}
Var jj : integer;
    AA, Added, Aux1, Aux2, Factor, Tau : real;
    Term : array of real;
//Symbols could be changed Factor -> Sum, Term -> Factor, Aux -> Term
begin

    Tau := Mu2/(Mu2+Mu1*XX);
    setlength (Term,3);
    Term[1]:=Mu2*(Mu2+2)/8;                        //factor of Tau
    Aux1:=Term[1]*sqr(1-Tau);                        //Third term
    Aux2:=Mu2*(1-tau)/2;
    Factor:=1+Aux2+Aux1;                      //Sum of first three terms
    jj:=1;
    Added:=4;
    while (Added<Mu1-3) and (jj<300) do
    begin
      jj:=jj+1;
      setlength (Term,jj+2);
      Term[jj]:=Term[jj-1]*(Mu2+Added)/(Added+2);
      AA:=(jj+1)*ln((1-Tau));
      AA:=exp(AA);
      Aux2:=Term[jj]*AA;                           //next term
      Factor:=Factor+Aux2;                         //Summation of terms
      Added:=Added+2;
    end; {while (Added<Mu1-3) and (jj<300) do}
    if Tau<1 then
    begin
      AA := (Mu2/2)*ln(Tau);
      AA := exp(AA);
    end
    else
      AA := 0;
    if Mu1=4 then Factor:=Factor-Aux1;
    if Mu1=2 then Factor:=1;
    if Mu1=1 then Factor:=0.6375;
    Probi := 100*(1-AA*Factor);
  if Probi>99.99 then Probi:=99.99;
end;
{end of FdisE}
{------------}



procedure TForm1.ProbdisO (Nu1, Nu2 : integer; Proba : real; var XX : real);
{-------------------------------------------------------------------------}
Var ii, jj : integer;
    AA, Added, Aux1, Aux2, Factor, Tau : real;
    Term : array of real;
//Symbols could be changed Factor -> Sum, Term -> Factor, Aux -> Term
begin
  XX:=0;
  Proba:=Proba/100;
  for ii:=1 to 100000 do
  begin
    XX:=XX+0.01;
    Tau := Nu2/(Nu2+Nu1*XX);
    setlength (Term,2);
    Term[1]:=Nu1*(Nu1+2)/8;                        //factor of Tau
    Aux1:=Term[1]*sqr(Tau);                        //Third term
    Factor:=1+Nu1*Tau/2+Aux1;                      //Sum of first three terms
    jj:=1;
    Added:=4;
    while (Added<Nu2-3) and (jj<300) do
    begin
      jj:=jj+1;
      setlength (Term,jj+1);
      Term[jj]:=Term[jj-1]*(Nu1+Added)/(Added+2);
      AA:=(jj+1)*ln(Tau);
      AA:=exp(AA);
      Aux2:=Term[jj]*AA;                           //next term
      Factor:=Factor+Aux2;                         //Summation of terms
      Added:=Added+2;
    end; {while (Added<Nu2-3) and (jj<300) do}
    if Tau<1 then
    begin
      AA := (Nu1/2)*ln(1-Tau);
      AA := exp(AA);
    end
    else
      AA := 0;
//    if Nu2=4 then Factor:=Factor-Aux1;
//    if Nu2=2 then Factor:=1;
//    if Nu2=1 then Factor:=0.6375;;
    Pro[ii] := AA*Factor;
    if Pro[ii]>Proba then exit;
  end; {for ii:=1 t0 100000 do}
end;
{end of ProbdisO}
{---------------}



procedure TForm1.ProbdisE (Mu1, Mu2 : integer; Proba : real; var XX : real);
{-------------------------------------------------------------------------}
Var ii, jj : integer;
    AA, Added, Aux1, Aux2, Factor, Tau : real;
    Term : array of real;
//Symbols could be changed Factor -> Sum, Term -> Factor, Aux -> Term
begin
  XX:=0;
  Proba:=Proba/100;
  for ii:=1 to 100000 do
  begin
    XX:=XX+0.01;
    Tau := Mu2/(Mu2+Mu1*XX);
    setlength (Term,3);
    Term[1]:=Mu2*(Mu2+2)/8;                        //factor of Tau
    Aux1:=Term[1]*sqr(1-Tau);                        //Third term
    Aux2:=Mu2*(1-tau)/2;
    Factor:=1+Aux2+Aux1;                      //Sum of first three terms
    jj:=1;
    Added:=4;
    while (Added<Mu1-3) and (jj<300) do
    begin
      jj:=jj+1;
      setlength (Term,jj+2);
      Term[jj]:=Term[jj-1]*(Mu2+Added)/(Added+2);
      AA:=(jj+1)*ln((1-Tau));
      AA:=exp(AA);
      Aux2:=Term[jj]*AA;                           //next term
      Factor:=Factor+Aux2;                         //Summation of terms
      Added:=Added+2;
    end; {while (Added<Mu1-3) and (jj<300) do}
    if Tau<1 then
    begin
      AA := (Mu2/2)*ln(Tau);
      AA := exp(AA);
    end
    else
      AA := 0;
//    if Mu1=4 then Factor:=Factor-Aux1;
//    if Mu1=2 then Factor:=1;
//    if Mu1=1 then Factor:=0.6375;
    Pro[ii] := 1-AA*Factor;
    if Pro[ii]>Proba then exit
  end; {for ii:=1 tO 100000 do}
end;
{end of ProbdisE}
{---------------}



procedure TForm1.Button3Click(Sender: TObject);
var i: integer; AuxVal : real;
begin
  if not Case2 then Case1:=true;
  AuxVal:=stringtofloat(Edit3.Text);
  DecimalSeparator:=InitDecSep;
  if Auxval>20 then
  begin
    showmessage ('Sorry, graph cannot be made for F-test values > 20');
    exit;
  end;
  if (Frac(DF1/2)=0) and (Frac(DF2/2)=0) then
  begin
    if DF1<=DF2 then MakeProbsE (DF1,DF2)
    else MakeProbs (DF1,DF2);
  end;
  if (Frac(DF1/2)=0) and (Frac(DF2/2)<>0) then MakeProbsE (DF1,DF2);
  if (Frac(DF1/2)<>0) and (Frac(DF2/2)<>0) then
  begin
      if DF1<DF2 then
      begin
        MakeProbs (DF1,DF2-1);
        for i:=1 to 999 do TmpVal[i]:=Fvalue[i];
        MakeProbs (DF1,DF2+1);
        for i:=1 to 999 do Fvalue[i]:=(3*Fvalue[i]+TmpVal[i])/4;
      end else
      begin
        MakeProbsE (DF1-1,DF2);
        for i:=1 to 999 do TmpVal[i]:=Fvalue[i];
        MakeProbsE (DF1+1,DF2);
        for i:=1 to 999 do Fvalue[i]:=(3*Fvalue[i]+TmpVal[i])/4;
      end;
  end;
  if (Frac(DF1/2)<>0) and (Frac(DF2/2)=0) then MakeProbs (DF1,DF2);

  if Case1 then MakeProbGraph;
  if Case2 then MakeFtestGraph;
  Case2:=false;

end;


procedure TForm1.Button4Click(Sender: TObject);
begin
  Case1:=false;
  Case2:=true;
  Button3Click(Sender);
end;

procedure TForm1.Button2Click(Sender: TObject);
var TmpValue : real;
begin

  if edit5.text='' then
  begin
    showmessage ('Please enter the probability value');
    exit;
  end;
  Case1:=false;
  Edit4.Text:='';
  Button3.Caption:='See F-testing graph';
  DF1:=strtoint(Edit1.text);
  DF2:=strtoint(Edit2.text);
  Probab:=stringtofloat(Edit5.text);
  DecimalSeparator:=InitDecSep;

  ProbdisE (DF1,DF2,Probab,Fval);
  ProbdisO (DF1,DF2,Probab,Fval);
  if (Frac(DF1/2)=0) and (Frac(DF2/2)=0) then
  begin
    if DF1<=DF2 then ProbdisE (DF1,DF2,Probab,Fval)
    else ProbdisO (DF1,DF2,Probab,Fval);
  end;
  if (Frac(DF1/2)=0) and (Frac(DF2/2)<>0) then ProbdisE (DF1,DF2,Probab,Fval);
  if (Frac(DF1/2)<>0) and (Frac(DF2/2)<>0) then
  begin
    if (DF1=1) and (DF2=1) then ProbdisE (DF1,DF2,Probab,Fval)
    else
      if DF1<DF2 then
      begin
        ProbdisO (DF1,DF2-1,Probab,Fval);
        TmpValue:=Fval;
        ProbdisO (DF1,DF2+1,Probab,Fval);
        Fval:=(3*Fval+TmpValue)/4;
      end else
      begin
        ProbdisE (DF1-1,DF2,Probab,Fval);
        TmpValue:=Fval;
        ProbdisE (DF1+1,DF2,Probab,Fval);
        Fval:=(3*Fval+TmpValue)/4;
      end;
  end;
  if (Frac(DF1/2)<>0) and (Frac(DF2/2)=0) then ProbdisO (DF1,DF2,Probab,Fval);
  if Fval<10 then
     Edit6.text:=format('%4.2f',[Fval])
  else if Fval<100 then
     Edit6.text:=format('%4.1f',[Fval])
  else
     Edit6.text:=format('%4.0f',[Fval]);
  MakeInitialGraph;
  Button3.Enabled:=true;
  Button4.Enabled:=true;
  Button5.Enabled:=true;
end;


procedure TForm1.Button5Click(Sender: TObject);
var AuxVal : real; ii :integer;
begin
  AuxVal:=stringtofloat(Edit3.Text);
  DecimalSeparator:=InitDecSep;
  if Auxval>10 then
  begin
    showmessage ('Sorry, the density graph cannot be made for'+
                 ' F-test values > 10');
    exit;
  end;

  for ii:=2 to 999 do
  begin
    Fvalue[ii]:=(ii/99)*AuxVal;
    Ftest:=Fvalue[ii];
    GetProb(sender);
    Probability[ii]:=Probabi;
  end;
  Probability[1]:=Probability[2];
  for ii:=1 to 998 do
    Density[ii]:=(Probability[ii+1]-Probability[ii])/(Fvalue[ii+1]-Fvalue[ii]);
  MakeDensGraph;
end;



procedure TForm1.MakeProbs (Nu1, Nu2 : integer);
{----------------------------------------------}
label 1;
Var ii, jj, kk : integer;
    AA, Added, Aux1, Aux2, Factor, Tau, Prob, XX : real;
    Term : array of real;
//Symbols could be changed Factor -> Sum, Term -> Factor, Aux -> Term
begin
  XX:=0.01;
  for ii:=1 to 999 do Probability[ii]:=ii*0.001;
  for kk:=1 to 999 do
  begin
    for ii:=1 to 100000 do
    begin
      XX:=XX+0.0001;
      Tau := Nu2/(Nu2+Nu1*XX);
      setlength (Term,2);
      Term[1]:=Nu1*(Nu1+2)/8;                        //factor of Tau
      Aux1:=Term[1]*sqr(Tau);                        //Third term
      Factor:=1+Nu1*Tau/2+Aux1;                      //Sum of first three terms
      jj:=1;
      Added:=4;
      while (Added<Nu2-3) and (jj<300) do
      begin
        jj:=jj+1;
        setlength (Term,jj+1);
        Term[jj]:=Term[jj-1]*(Nu1+Added)/(Added+2);
        AA:=(jj+1)*ln(Tau);
        AA:=exp(AA);
        Aux2:=Term[jj]*AA;                           //next term
        Factor:=Factor+Aux2;                         //Summation of terms
        Added:=Added+2;
      end; {while (Added<Nu2-3) and (jj<300) do}
      if Tau<1 then
      begin
        AA := (Nu1/2)*ln(1-Tau);
        AA := exp(AA);
      end
      else
        AA := 0;
      if Nu2=4 then Factor:=Factor-Aux1;
      if Nu2=2 then Factor:=1;
      if Nu2=1 then Factor:=0.6375;
      Prob := AA*Factor;
      if Prob>Probability[kk] then
      begin
        Fvalue[kk]:=XX;
        goto 1;
      end;
    end; {for ii:=1 t0 100000 do}
1:end; {for kk:=1 to 999 do}
end;
{end of MakeProbs}
{----------------}




procedure TForm1.MakeProbsE (Mu1, Mu2 : integer);
{-----------------------------------------------}
label 1;
Var ii, jj, kk : integer;
    AA, Added, Aux1, Aux2, Factor, Tau, Prob, XX : real;
    Term : array of real;
//Symbols could be changed Factor -> Sum, Term -> Factor, Aux -> Term
begin
  XX:=0.01;
  for ii:=1 to 999 do Probability[ii]:=ii*0.001;
  for kk:=1 to 999 do
  begin
    for ii:=1 to 100000 do
    begin
      XX:=XX+0.0001;
      Tau := Mu2/(Mu2+Mu1*XX);
      setlength (Term,3);
      Term[1]:=Mu2*(Mu2+2)/8;                        //factor of Tau
      Aux1:=Term[1]*sqr(1-Tau);                        //Third term
      Aux2:=Mu2*(1-tau)/2;
      Factor:=1+Aux2+Aux1;                      //Sum of first three terms
      jj:=1;
      Added:=4;
      while (Added<Mu1-3) and (jj<300) do
      begin
        jj:=jj+1;
        setlength (Term,jj+2);
        Term[jj]:=Term[jj-1]*(Mu2+Added)/(Added+2);
        AA:=(jj+1)*ln((1-Tau));
        AA:=exp(AA);
        Aux2:=Term[jj]*AA;                           //next term
        Factor:=Factor+Aux2;                         //Summation of terms
        Added:=Added+2;
      end; {while (Added<Mu1-3) and (jj<300) do}
      if Tau<1 then
      begin
        AA := (Mu2/2)*ln(Tau);
        AA := exp(AA);
      end
      else
        AA := 0;
      if Mu1=4 then Factor:=Factor-Aux1;
      if Mu1=2 then Factor:=1;
      if Mu1=1 then Factor:=0.6375;
      Prob := 1-AA*Factor;
      if Prob>Probability[kk] then
      begin
        Fvalue[kk]:=XX;
        goto 1;
      end;
    end; {for ii:=1 to 100000 do}
1:end; {for kk:=1 to 999 do}
end;
{end of MakeProbsE}
{-----------------}



procedure TForm1.MakeInitialGraph;
var DumReal : real; NameStr : string;
    ii : integer;
    MinX, MinY, MaxX, MaxY   : integer;
    ScaleX, ScaleY, LX, LY   : integer;
    DecimX, DecimY           : integer;
    myRect : TRect;
begin
  MinX:=0;
  MaxX:=10;
  MinY:=0;
  MaxY:=1;
  ScaleX:=10;
  ScaleY:=10;
  LX := posX2-posX1;
  LY := posY2-posY1;
  DecimY:=1;
  DecimX:=1;

  With Form1.Image1.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(Form1.Image1.Canvas.ClipRect);
    Font.Size := 8;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,425,295);
    FillRect (myRect);

    Textout (30,3,'Waiting for graphics instructions');
    TextOut (20,275,'F-test calculator at www.waterlog.info/f-test.htm');
    Brush.Color := clblue;
    myRect:= Rect(20,19,405,273);
    FillRect (myRect);

    Brush.Color:=clMoneyGreen;
    myRect:= Rect(82,82,368,178);
    FillRect (myRect);

    TextOut (90, 100, ' Use the "See graph" buttons for graphic inspection.');
    TextOut (90, 130, ' If disabled, the "See graph" button will be enabled');
    TextOut (90, 145, ' after using the "Calculate" button.');

    Brush.Color := clblue;
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    Pen.Width := 1;
    Font.Color := clWhite;

    moveto (PosX1,PosY2);                                            {the axes}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    for ii:=0 to ScaleY do                                    { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                        IntToStr(decimY) + 'f', [MaxY - DumReal]);
                 {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;
                                                            { horizontal axis }
    for ii:=0 to ScaleX do
    begin
      Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
      Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
      DumReal := ii*(MaxX-MinX)/ScaleX;
      NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                        IntToStr(decimX) + 'f', [(MinX+DumReal)]);
      Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

  end; {with Image.canvas do}
end; {MakeInitialGraph}



procedure TForm1.MakeProbGraph;
{-----------------------------}
label 1;
var DumReal : real; NameStr  : string;
    FrqTxt, XrTxt            : string;
    XdataRel,YdataRel        : real;
    Xmax, AuxVar, HlpVar     : real;
    ProbVal                  : real;
    MinX, MinY, MaxX, MaxY   : integer;
    ScaleX, ScaleY, LX, LY   : integer;
    DecimX, DecimY, ii       : integer;
    RelXdata, RelYdata       : integer;
    RelX, RelY               : integer;
    myRect                   : TRect;
begin
  Xmax:=0;
  for ii:=1 to 999 do
    if Fvalue[ii]>Xmax then Xmax:=Fvalue[ii];
  HlpVar := StringToFloat (Edit3.Text);
  if HlpVar>Xmax then Xmax:=HlpVar;
  if Xmax<5 then Xmax:=5;
  if Xmax>20 then
  begin
    Xmax:=20;
    for ii:=1 to 999 do Fvalue[ii]:=Fvalue[ii]*20/Xmax;
  end;
  if Case1 then AuxVar := StringToFloat (Edit3.Text)
  else AuxVar := StringToFloat (Edit5.Text);
  ProbVal:=0.99;
  for ii:=1 to 999 do
    if (Fvalue[ii]>=AuxVar) then
    begin
      ProbVal:=Probability[ii];
      goto 1;
    end;
1:MinX:=0;
  MaxX:=round(Xmax+0.5);
  MinY:=0;
  MaxY:=1;
  ScaleX:=10;
  ScaleY:=10;
  LX := posX2-posX1;
  LY := posY2-posY1;
  DecimX:=1;
  if Xmax<1 then DecimX:=2;
  DecimY:=1;

  With Form1.Image1.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(Form1.Image1.Canvas.ClipRect);
    Font.Size := 8;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,425,295);
    FillRect (myRect);
    Textout (30,3,'Calculated cumulative probability for a given'+
                       ' F-test value');
    Font.Size := 7;
    TextOut (20,276,'F-test calculator at www.waterlog.info/f-test.htm');
    Brush.Color := clblue;
    myRect:= Rect(20,19,405,273);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    Pen.Width := 1;

    Font.Color := clWhite;
    Textout (345,255,'F-test');
    FrqTxt:='DF-num = '+Edit1.Text;
    XrTxt :='  DF-den= '+Edit2.Text;
    XrTxt:=FrqTxt+XrTxt;
    TextOut (32,20,XrTxt);
    TextOut (PosX1,35,'Cumulative probability');
    XrTxt := Edit3.Text;
    AuxVar:= stringtofloat(XrTxt);
    XrTxt := format('%5.2f',[AuxVar]);
    XrTxt:='Given F-value = '+XrTxt;
    TextOut (200,20,XrTxt);
    XrTxt:= Edit4.Text;
    AuxVar:= stringtofloat(XrTxt);
    AuxVar:=AuxVar/100;
    XrTxt := format('%5.3f',[AuxVar]);
    XrTxt:='Calculated probability = '+XrTxt;
    TextOut (200,32,XrTxt);

    moveto (PosX1,PosY2);                                            {the axes}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    for ii:=0 to ScaleY do                                    { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                        IntToStr(decimY) + 'f', [MaxY - DumReal]);
                 {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;
                                                            { horizontal axis }
    for ii:=0 to ScaleX do
    begin
      Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
      Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
      DumReal := ii*(MaxX-MinX)/ScaleX;
      NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                        IntToStr(decimX) + 'f', [(MinX+DumReal)]);
      Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

    for ii:=1 to 998 do
    begin
      XdataRel := LX * (Fvalue[ii] - MinX) /(MaxX-MinX);
      RelXdata := PosX1+round(XdataRel);
      YdataRel := LY*(Probability[ii]-MinY)/(MaxY-MinY);
      RelYdata := PosY2-round(YdataRel);

      if Fvalue[ii]<20 then moveto (RelXdata,RelYdata);

      XdataRel := LX * (Fvalue[ii+1] - MinX) /(MaxX-MinX);
      RelXdata := PosX1+round(XdataRel);
      YdataRel := LY*(Probability[ii+1]-MinY)/(MaxY-MinY);
      RelYdata := PosY2-round(YdataRel);
      RelX     := RelXdata;
      RelY     := RelYdata;

      if Fvalue[ii]<20 then lineto (RelXdata,RelYdata);

    end;
    RelXdata:=RelX;
    RelYdata:=RelY;
    if (Fvalue[998]<XMax) then
    begin
      moveto (RelXdata,RelYdata);
      RelXdata := PosX1+round(LX);
      lineto (RelXdata,RelYdata);
    end;

    XdataRel := LX * (HlpVar - MinX) /(MaxX-MinX);
    RelXdata := PosX1+round(XdataRel);
    DecimalSeparator:=InitDecSep;
    YdataRel := LY*(ProbVal-MinY)/(MaxY-MinY);
    RelYdata := PosY2-round(YdataRel);
    Pen.Color:=clRed;
    Pen.Style := psDot;
    if ProbVal<0.2 then Pen.Style := psSolid;;
    if ProbVal<0.1 then Pen.Width:=2;
    moveto (RelXdata,PosY2);
    if (MaxX<10) and (Fvalue[998]<MaxX) then RelYdata := PosY2-round(LY);
    lineto (RelXdata,RelYdata);

  end; {with Image.canvas do}
end; {MakeProbGraph}



procedure TForm1.MakeFtestGraph;
Label 1, 2;
var DumReal : real; NameStr  : string;
    ii                       : integer;
    XdataRel,YdataRel, Fvar  : real;
    Ymax, AuxVar             : real;
    MinX, MinY, MaxX, MaxY   : integer;
    ScaleX, ScaleY, LX, LY   : integer;
    DecimX, DecimY           : integer;
    RelXdata, RelYdata       : integer;
    FrqTxt, XrTxt : string;
    myRect : TRect;
begin
  Ymax:=0;
  for ii:=1 to 999 do if Fvalue[ii]>Ymax then
      Ymax:=Fvalue[ii];
  if Ymax>20 then Ymax:=20;
1:MinY:=0;
  MaxY:=round(Ymax);
  if MaxY=0 then MaxY:=1;
  if MaxY<5 then MaxY:=5;
  if MaxY>=5 then MaxY:=8;
  if MaxY>=8 then MaxY:=20;
  MinX:=0;
  MaxX:=1;
  ScaleX:=10;
  ScaleY:=5;
  LX := posX2-posX1;
  LY := posY2-posY1;
  DecimY:=0;
  if Ymax<1 then DecimY:=2;
  if Ymax<10 then DecimY:=1;
  DecimX:=1;

  With Form1.Image1.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(Form1.Image1.Canvas.ClipRect);
    Font.Size := 8;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,425,295);
    FillRect (myRect);
    Textout (30,3,'Calculated F-test value for a given cumulative probability');
    Font.Size := 7;
    TextOut (20,276,'F-test calculator at www.waterlog.info/f-test.htm');
    Brush.Color := clblue;
    myRect:= Rect(20,19,405,273);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    Pen.Width := 1;

    Font.Color := clWhite;
    Textout (330,255,'Probability');
    FrqTxt:='DF-num = '+Edit1.Text;
    XrTxt :='  DF-den= '+Edit2.Text;
    XrTxt:=FrqTxt+XrTxt;
    TextOut (32,20,XrTxt);
    TextOut (PosX1,40,'F-test value');
    XrTxt := Edit3.Text;
    AuxVar:= stringtofloat(XrTxt);
    XrTxt := format('%5.2f',[AuxVar]);
    XrTxt:='Given F-test value = '+XrTxt;
    TextOut (80,80,XrTxt);
    XrTxt := Edit4.Text;
    AuxVar:= stringtofloat(XrTxt)/100;
    XrTxt := format('%5.3f',[AuxVar]);
    XrTxt:='Calculated probability = '+XrTxt;
    TextOut (80,95,XrTxt);

    moveto (PosX1,PosY2);                                            {the axes}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    for ii:=0 to ScaleY do                                    { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                        IntToStr(decimY) + 'f', [MaxY - DumReal]);
                 {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
      Textout ((posX1-TextWidth(NameStr)-6),
              (round(posY1+(ii/ScaleY)*LY)-round(1/2*TextHeight(NameStr))),
               NameStr);
    end;
                                                            { horizontal axis }
    for ii:=0 to ScaleX do
    begin
      Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
      Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
      DumReal := ii*(MaxX-MinX)/ScaleX;
      NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                        IntToStr(decimX) + 'f', [(MinX+DumReal)]);
      Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

    for ii:=1 to 999 do
    begin
      XdataRel := LX * (Probability[ii] - MinX) /(MaxX-MinX);
      RelXdata := PosX1+round(XdataRel);
      YdataRel := LY*(Fvalue[ii]-MinY)/(MaxY-MinY);
      RelYdata := PosY2-round(YdataRel);

      if Fvalue[ii]<Ymax then moveto (RelXdata,RelYdata);

      XdataRel := LX * (Probability[ii+1] - MinX) /(MaxX-MinX);
      RelXdata := PosX1+round(XdataRel);
      YdataRel := LY*(Fvalue[ii+1]-MinY)/(MaxY-MinY);
      RelYdata := PosY2-round(YdataRel);

      if Fvalue[ii]<Ymax then lineto (RelXdata,RelYdata);

      if Fvalue[ii]>Ymax then goto 2;

    end;

2:  if (DF1>2) and (DF2>2) then
    if (Fvalue[998]<Ymax) and (Fvalue[998]>1) then
    begin
      XdataRel := LX * (Probability[998] - MinX) /(MaxX-MinX);
      RelXdata := PosX1+round(XdataRel);
      YdataRel := LY*(Fvalue[998]-MinY)/(MaxY-MinY);
      RelYdata := PosY2-round(YdataRel);
      moveto (RelXdata,RelYdata);
      XdataRel := LX * (Probability[998] - MinX) /(MaxX-MinX);
      RelXdata := PosX1+round(XdataRel);
      YdataRel := LY;
      RelYdata := PosY2-round(YdataRel);
      lineto ( RelXdata,RelYdata);
    end;

    AuxVar := StringToFloat (Edit4.Text)/100;
    FVar := StringToFloat (Edit3.Text);
    XdataRel := LX * (AuxVar - MinX) /(MaxX-MinX);
    RelXdata := PosX1+round(XdataRel);
    YdataRel := LY*(Fvar-MinY)/(MaxY-MinY);
    RelYdata := PosY2-round(YdataRel);
    Pen.Color:=clred;
    moveto (RelXdata,PosY2);
    if (MaxY<2) then RelYdata := PosY2-round(LY);
    if Ymax>8 then
       if (DF1>2) and (DF2>2) then RelYdata := PosY2-round(YdataRel);
    lineto (RelXdata,RelYdata);

  end; {with Image.canvas do}
end; {MakeFtestGraph}


procedure TForm1.MakeDensGraph;
label 1;
var DumReal : real; NameStr,
    FrqTxt, XrTxt            : string;
    XdataRel,YdataRel,Upper,
    OptiF, Lower, Topper      : real;
    Xmax, AuxVar, MaxDens    : real;
    RelXdata1,RelYdata1,
    RelXdata2,RelYdata2      : integer;
    MinX, MinY, MaxX, MaxY   : integer;
    ScaleX, ScaleY, LX, LY   : integer;
    DecimX, DecimY, ii       : integer;
    RelXdata, RelYdata       : integer;
    myRect                   : TRect;
begin
  MinX:=0;
  MaxDens:=0;
  OptiF:=0;
  for ii:=1 to 999 do if Density[ii]>MaxDens then
  begin
    MaxDens:=Density[ii];
    OptiF:=Fvalue[ii];
  end;
  MaxX:=round(3*(OptiF+0.5));
  if MaxX<5 then MaxX:=5
  else if (MaxX>=5) and (MaxX<10) then MaxX:=10
  else MaxX:=20;
  ScaleX:=5;
  MinY:=0;
  ScaleY:=1;
  MaxY:=round(1.1*MaxDens+0.5);
  LX := posX2-posX1;
  LY := posY2-posY1;
  DecimX:=0;
  DecimY:=1;

  With Form1.Image1.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(Form1.Image1.Canvas.ClipRect);
    Font.Size := 8;
    Font.Color := clBlack;
    Font.Name := 'Arial';
    Brush.Color:=clSilver;
    myRect:= Rect(0,0,425,295);
    FillRect (myRect);
    Textout (30,3,'Calculated cumulative probability for a given'+
                       ' F-test value');
    Font.Size := 7;
    TextOut (20,276,'F-test calculator at www.waterlog.info/f-test.htm');
    Brush.Color := clblue;
    myRect:= Rect(20,19,405,273);
    FillRect (myRect);
    Pen.Style := psSolid;
    Pen.Color := clWhite;        {for the lines}
    Pen.Width := 1;

    Font.Color := clWhite;
    Textout (345,255,'F-test');
    FrqTxt:='DF-num = '+Edit1.Text;
    XrTxt :='  DF-den= '+Edit2.Text;
    XrTxt:=FrqTxt+XrTxt;
    TextOut (32,20,XrTxt);
    TextOut (PosX1,38,'F-distribution density');
    XrTxt:='Given F-test = '+Edit3.Text;
    TextOut (200,20,XrTxt);
    XrTxt := Edit4.Text;
    AuxVar:= stringtofloat(XrTxt);
    AuxVar:=AuxVar/100;
    XrTxt := format('%5.3f',[AuxVar]);
    XrTxt:='Calculated probability = '+XrTxt;
    TextOut (200,32,XrTxt);
    TextOut (200,44,'(Green area)');

    moveto (PosX1,PosY2);                                            {the axes}
    lineto (PosX1,PosY1);
    moveto (PosX1,PosY2);
    lineto (PosX2,PosY2);

    for ii:=0 to ScaleY do                                    { vertical axis }
    begin
      Moveto (posX1,round(posY1+(ii/ScaleY)*LY));
      Lineto (posX1-4, round(posY1+(ii/ScaleY)*LY));
      DumReal := ii/ScaleY*(MaxY-MinY);
      NameStr := format('%' + IntToStr(2 + decimY) + '.' +
                        IntToStr(decimY) + 'f', [MaxY/10 - DumReal/10]);
                 {bijv. '%3.1f' voor 1 decimaal, 3 cijfers, float number}
    end;
                                                            { horizontal axis }
    for ii:=0 to ScaleX do
    begin
      Moveto(round(posX1+(ii/ScaleX)*LX), posY2);
      Lineto(round(posX1+(ii/ScaleX)*LX), PosY2+4);
      DumReal := ii*(MaxX-MinX)/ScaleX;
      NameStr := format('%' + IntToStr(2 + decimX) + '.' +
                        IntToStr(decimX) + 'f', [(MinX+DumReal)]);
      Textout (round(posX1-8+(ii/ScaleX)*LX), PosY2+12, NameStr);
    end;

    Upper := StringToFloat (Edit3.Text);
    YdataRel := LY*(0.5*(Density[1]+Density[2])-MinY)/(MaxY-MinY);
    RelYdata1 := PosY2-round(YdataRel);
    Brush.Color := clTeal;
    XdataRel := LX * (Fvalue[2] - MinX) /(MaxX-MinX);
    RelXdata2 := PosX1+round(XdataRel);
    Fillrect (Rect(PosX1,RelYData1,RelXdata2,PosY2));
    Brush.Color := clblue;
    Lower:=0.01;
    Topper:=0.99;

    for ii:=1 to 999 do
    begin

    if Probability[ii]<1 then
       Lower:=Fvalue[ii];
    if Probability[ii]<99 then
       Topper:=Fvalue[ii];

      XdataRel := LX * (Fvalue[ii]- MinX) /(MaxX-MinX);
      RelXdata1 := PosX1+round(XdataRel);
      YdataRel := LY*(Density[ii]-MinY)/(MaxY-MinY);
      RelYdata1 := PosY2-round(YdataRel);
      XdataRel := LX * (Fvalue[ii+1] - MinX) /(MaxX-MinX);
      RelXdata2 := PosX1+round(XdataRel);

      if Fvalue[ii]<Upper then
      begin
        Brush.Color := clTeal;
        Fillrect (Rect(RelXdata1,RelYData1,RelXdata2,PosY2));
      end;

      XdataRel := LX * (Fvalue[ii] - MinX) /(MaxX-MinX);
      RelXdata1 := PosX1+round(XdataRel);
      YdataRel := LY*(Density[ii]-MinY)/(MaxY-MinY);
      RelYdata1 := PosY2-round(YdataRel);
      XdataRel := LX * (Fvalue[ii+1] - MinX) /(MaxX-MinX);
      RelXdata2 := PosX1+round(XdataRel);
      YdataRel := LY*(Density[ii+1]-MinY)/(MaxY-MinY);
      RelYdata2 := PosY2-round(YdataRel);

      if Fvalue[ii]>MaxX then goto 1;

      moveto (RelXdata1,RelYdata1);
      lineto (RelXdata2,RelYdata2);

    end;

1:  XdataRel := LX * (OptiF - MinX) /(MaxX-MinX);
    RelXdata := PosX1+round(XdataRel);
    YdataRel := LY*(MaxDens-MinY)/(MaxY-MinY);
    RelYdata := PosY2-round(YdataRel);
    Pen.Style := psDot;
    moveto (RelXdata,RelYdata);
    lineto (PosX1,RelYdata);
    AuxVar:=0.02*strtofloat(Edit4.Text)/(Topper-Lower);
    NameStr:=format('%5.2f',[AuxVar]);
    Brush.Color := clblue;
    Textout ( posX1-TextWidth(NameStr)-6,RelYdata-6,NameStr);
    AuxVar:=0;
    NameStr:=format('%5.2f',[AuxVar]);
    Textout ( posX1-TextWidth(NameStr)-6,PosY2-6,NameStr);

  end; {with Image.canvas do}

end; {TForm1.MakeDensGraph}


function TForm1.StringToFloat(Str : string) : double;
{accepts comma or point for decimal separator}
var
  OldDecSep : char;
begin
  try
    Result := StrToFloat(Str);
  except
    on EConvertError do begin
      OldDecSep := DecimalSeparator;
      {change to other decimal separator}
      if DecimalSeparator = ',' then
        DecimalSeparator := '.'
      else
        DecimalSeparator := ',';
      Result := StrToFloat(Str);
      {revert to original decimal separator}
      DecimalSeparator := OldDecSep;
    end;
  end;
end; {TForm1.StringToFloat}



procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Action := caNone;
     Form2.Show;
end; {TMainForm.FormClose}



end.
